---
title: Element.getElementsByClassName()
slug: Web/API/Element/getElementsByClassName
tags:
  - API
  - Classes
  - Element
  - Method
  - Reference
  - getElementsByClassName
---
<div>{{APIRef("DOM")}}</div>

<p><span class="seoSummary">The {{domxref("Element")}} method <code><strong>getElementsByClassName()</strong></code> returns a live {{domxref("HTMLCollection")}} which contains every descendant element which has the specified class name or names.</span></p>

<p>The method {{domxref("Document.getElementsByClassName", "getElementsByClassName()")}} on the {{domxref("Document")}} interface works essentially the same way, except it acts on the entire document, starting at the document root.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>var <em>elements</em></var> = <em>element</em>.getElementsByClassName(<em>names</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>names</code></dt>
 <dd>A {{domxref("DOMString")}} containing one or more class names to match on, separated by whitespace.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("HTMLCollection")}} providing a live-updating list of every element which is a member of every class in <code>names</code>.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>As always, the returned collection is <em>live</em>, meaning that it always reflects the current state of the DOM tree rooted at the element on which the function was called. As new elements that match <code>names</code> are added to the subtree, they immediately appear in the collection. Similarly, if an existing element that doesn't match <code>names</code> has its set of classes adjusted so that it matches, it immediately appears in the collection.</p>

<p>The opposite is also true; as elements no longer match the set of names, they are immediately removed from the collection.</p>

<div class="note">
<p>In <a href="/en-US/docs/Web/HTML/Quirks_Mode_and_Standards_Mode">quirks mode</a>, the class names are compared in a case-insensitive fashion. Otherwise, they're case sensitive.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Matching_a_single_class">Matching a single class</h3>

<p>To look for elements that include among their classes a single specified class, we just provide that class name when calling <code>getElementsByClassName()</code>:</p>

<pre class="brush: js notranslate">element.getElementsByClassName('test');</pre>

<p>This example finds all elements that have a class of <code>test</code>, which are also a descendant of the element that has the <code>id</code> of <code>main</code>:</p>

<pre class="brush: js notranslate">document.getElementById('main').getElementsByClassName('test');</pre>

<h3 id="Matching_multiple_classes">Matching multiple classes</h3>

<p>To find elements whose class lists include both the <code>red</code> and <code>test</code> classes:</p>

<pre class="brush: js notranslate">element.getElementsByClassName('red test');</pre>

<h3 id="Examining_the_results">Examining the results</h3>

<p>You can use either the {{domxref("HTMLCollection.item", "item()")}} method on the returned <code>HTMLCollection</code> or standard array syntax to examine individual elements in the collection. However <u><strong>the following code will not work</strong></u> as one might expect because <code>"matches"</code> will change as soon as any <code>"colorbox"</code> class is removed.</p>

<pre class="brush: js notranslate">var matches = element.getElementsByClassName('colorbox');

for (var i=0; i&lt;matches.length; i++) {
  matches[i].classList.remove('colorbox');
  matches.item(i).classList.add('hueframe');
}
</pre>

<p>Instead, use another method, such as:</p>

<pre class="brush: js notranslate">var matches = element.getElementsByClassName('colorbox');

while (matches.length &gt; 0) {
  matches.item(0).classList.add('hueframe');
  matches[0].classList.remove('colorbox');
}</pre>

<p>This code finds descendant elements with the <code>"colorbox"</code> class, adds the class <code>"hueframe"</code>, by calling <code>item(0), </code>then removes <code>"colorbox" </code>(using array notation). Another element (if any are left) will then become <code>item(0)</code>.</p>

<h3 id="Filtering_the_results_using_array_methods">Filtering the results using array methods</h3>

<p>We can also use methods of {{jsxref("Array.prototype")}} on any {{ domxref("HTMLCollection") }} by passing the {{domxref("HTMLCollection")}} as the method's <code>this</code> value. Here we'll find all {{HTMLElement("div")}} elements that have a class of <code>test</code>:</p>

<pre class="brush: js notranslate">var testElements = document.getElementsByClassName('test');
var testDivs = Array.prototype.filter.call(testElements, function(testElement) {
  return testElement.nodeName === 'DIV';
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-element-getelementsbyclassname', 'Element.getElementsByClassName()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.getElementsByClassName")}}</p>
